#ifdef HAVE_CONFIG_H
#	include <config.h>
#endif

#include <lzma_adv.h>
#include <stdio.h>

#define BUFFER_SIZE 8192

int
main()
{
	lzma_init();

	uint8_t in[BUFFER_SIZE];
	uint8_t out[BUFFER_SIZE];

	FILE *ifile = fopen("zzz.lzma", "r");
	FILE *ofile = stdout; // fopen("/dev/null", "w");

	lzma_stream strm = LZMA_STREAM_INIT;
	{
/*
		lzma_options_block block = {
			.check = LZMA_CHECK_CRC32,
			.has_crc32 = 1,
			.uncompressed_size = UINT64_MAX,
			.compressed_size = UINT64_MAX,
		};
		const lzma_ret ret = lzma_block_decoder(&strm, &block);
*/
		const lzma_ret ret = lzma_auto_decoder(&strm, NULL, NULL);
		if (ret != LZMA_OK) {
			fprintf(stderr, "error init: %d\n", ret);
			return 1;
		}
	}

	while (1) {
		strm.next_in = in;
		strm.avail_in = fread(in, 1, BUFFER_SIZE, ifile);

		do {
			strm.next_out = out;
			strm.avail_out = BUFFER_SIZE;

			const lzma_ret ret = lzma_code(&strm, LZMA_RUN);
			fwrite(out, 1, BUFFER_SIZE - strm.avail_out, ofile);

			if (ret == LZMA_STREAM_END)
				goto out;

			if (ret != LZMA_OK) {
				fprintf(stderr, "error run: %d\n", ret);
				return 1;
			}

// 			fprintf(stderr, "ok: %u\n", strm.avail_in);

		} while (strm.avail_in > 0);
	}

out:
	if (!feof(ifile)) {
		fprintf(stderr, "warning: garbage at the end of the file\n");
	}

	lzma_end(&strm);

	if (ifile != stdin)
		fclose(ifile);

	if (ofile != stdout)
		fclose(ofile);

	return 0;
}
