///////////////////////////////////////////////////////////////////////////////
//
/// \file       alone_common.h
/// \brief      Shared parts for LZMA_Alone encoder and ecoder
//
//  Copyright (C) 2007 Lasse Collin
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//
///////////////////////////////////////////////////////////////////////////////

#ifndef LZMA_ALONE_COMMON_H
#define LZMA_ALONE_COMMON_H

#include "common.h"

struct lzma_coder_s {
	lzma_next_coder next;

	enum {
		SEQ_UNINITIALIZED,
		SEQ_PROPERTIES,
		SEQ_DICTIONARY_SIZE,
		SEQ_UNCOMPRESSED_SIZE,
		SEQ_CODER_INIT,
		SEQ_CODE,
		SEQ_END,
	} sequence;

	size_t pos;

	lzma_options_lzma options;
	uint64_t uncompressed_size;
};

#endif
